package com.fp.persistence.parmas.fun;

import javax.persistence.Entity;

import java.sql.Timestamp;

import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;

import java.io.Serializable;

import javax.persistence.Table;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

import javax.persistence.Version;

import java.lang.reflect.Field;

import javax.persistence.Transient;

import java.sql.Date;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TARMMOVIMIENTOARMAS*/
@Entity(name="TarmMovimientoArmas")
@Table(name="TARMMOVIMIENTOARMAS")
public class TarmMovimientoArmas extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable, Log {
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TarmMovimientoArmas
*/
@Id
@Column(name="CMOVIMIENTO" ,nullable=false, updatable=false)
private String pk;
@Column(name="FACTURA", nullable=true)

/**
* Número de Factura
*/
private String factura;

@Column(name="FECHA", nullable=true)

/**
* Fecha de registro
*/
private Timestamp fecha;

@Column(name="JUSTIFICACION", nullable=true)

/**
* Comentario en el cual se justifica el movimiento del material
*/
private String justificacion;

@Column(name="NOREGISTRO", nullable=true)

/**
* Número de Registro
*/
private String noregistro;



@Column(name="TIPOMOVIMIENTOCODIGO", nullable=true)

/**
* Codigo de tabla de catalogo 01 Codigo de tabla de tipos de movimiento
*/
private String tipomovimientocodigo;

@Column(name="CARMA", nullable=true)

/**
* Codigo del arma la cual se vende, transpasa, entre otros.
*/
private String carma;

@Column(name="PERSONCODEVENDEDOR", nullable=true)

/**
* Codigo de persona vendedora
*/
private Integer personcodevendedor;

@Column(name="TIPOMOVIMIENTO", nullable=true)

/**
* Codigo de catalogo  01 Venta, 02 Produccion
*/
private String tipomovimiento;

@Version
@Column(name="RECORDVERSION", nullable=true)

/**
* Versión del Registro
*/
private Integer recordversion;

@Column(name="PERSONCODECOMPRADOR", nullable=true)

/**
* Codigo de persona compradora

*/
private Integer personcodecomprador;

/**Contructor por defecto*/
public TarmMovimientoArmas(){
}
/**Contructor de TarmMovimientoArmas
@param pPk Clave Primaria del entity
*/
public TarmMovimientoArmas(String pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TarmMovimientoArmas
*/
public static TarmMovimientoArmas find(EntityManager pEntityManager,Object pKey) throws Exception{
    TarmMovimientoArmas obj = pEntityManager.find(TarmMovimientoArmas.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TarmMovimientoArmas
@return El objeto que referencia a la Clave primaria de TarmMovimientoArmas
*/
public String getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TarmMovimientoArmas
@param pPk El objeto que referencia a la nueva Clave primaria de TarmMovimientoArmas
*/
public void setPk(String pPk){
  pk=pPk;
}
/**Obtiene el valor de factura
@return valor de factura*/
public String getFactura(){
  return factura;
}
/**Fija el valor de factura
@param pFactura nuevo Valor de factura*/
public void setFactura(String pFactura){
  factura=pFactura;
}

/**Obtiene el valor de fecha
@return valor de fecha*/
public Timestamp getFecha(){
  return fecha;
}
/**Fija el valor de fecha
@param pFecha nuevo Valor de fecha*/
public void setFecha(Timestamp pFecha){
  fecha=pFecha;
}

/**Obtiene el valor de justificacion
@return valor de justificacion*/
public String getJustificacion(){
  return justificacion;
}
/**Fija el valor de justificacion
@param pJustificacion nuevo Valor de justificacion*/
public void setJustificacion(String pJustificacion){
  justificacion=pJustificacion;
}

/**Obtiene el valor de noregistro
@return valor de noregistro*/
public String getNoregistro(){
  return noregistro;
}
/**Fija el valor de noregistro
@param pNoregistro nuevo Valor de noregistro*/
public void setNoregistro(String pNoregistro){
  noregistro=pNoregistro;
}

/**Obtiene el valor de fecha

/**Fija el valor de fecha


/**Obtiene el valor de tipomovimientocodigo
@return valor de tipomovimientocodigo*/
public String getTipomovimientocodigo(){
  return tipomovimientocodigo;
}
/**Fija el valor de tipomovimientocodigo
@param pTipomovimientocodigo nuevo Valor de tipomovimientocodigo*/
public void setTipomovimientocodigo(String pTipomovimientocodigo){
  tipomovimientocodigo=pTipomovimientocodigo;
}

/**Obtiene el valor de carma
@return valor de carma*/
public String getCarma(){
  return carma;
}
/**Fija el valor de carma
@param pCarma nuevo Valor de carma*/
public void setCarma(String pCarma){
  carma=pCarma;
}

/**Obtiene el valor de personcodevendedor
@return valor de personcodevendedor*/
public Integer getPersoncodevendedor(){
  return personcodevendedor;
}
/**Fija el valor de personcodevendedor
@param pPersoncodevendedor nuevo Valor de personcodevendedor*/
public void setPersoncodevendedor(Integer pPersoncodevendedor){
  personcodevendedor=pPersoncodevendedor;
}

/**Obtiene el valor de tipomovimiento
@return valor de tipomovimiento*/
public String getTipomovimiento(){
  return tipomovimiento;
}
/**Fija el valor de tipomovimiento
@param pTipomovimiento nuevo Valor de tipomovimiento*/
public void setTipomovimiento(String pTipomovimiento){
  tipomovimiento=pTipomovimiento;
}

/**Obtiene el valor de recordversion
@return valor de recordversion*/
public Integer getRecordversion(){
  return recordversion;
}
/**Fija el valor de recordversion
@param pRecordversion nuevo Valor de recordversion*/
public void setRecordversion(Integer pRecordversion){
  recordversion=pRecordversion;
}

/**Obtiene el valor de personcodecomprador
@return valor de personcodecomprador*/
public Integer getPersoncodecomprador(){
  return personcodecomprador;
}
/**Fija el valor de personcodecomprador
@param pPersoncodecomprador nuevo Valor de personcodecomprador*/
public void setPersoncodecomprador(Integer pPersoncodecomprador){
  personcodecomprador=pPersoncodecomprador;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TarmMovimientoArmas))return false;
    TarmMovimientoArmas that = (TarmMovimientoArmas) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TarmMovimientoArmas
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TarmMovimientoArmas
*/
public Object createInstance(){
 TarmMovimientoArmas instance=new TarmMovimientoArmas();	
 return instance;
}
/**Clona la entidad TarmMovimientoArmas
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TarmMovimientoArmas p=(TarmMovimientoArmas)this.clone();
  return p;
}
}
